﻿//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// sb_EdgeBlend
// by Simon Björk
// Version 1.0.
// July 2011

// Based on a technique described in Mark Christiansens book "After Effects CS4 Studio Techniques". 

// Select your foreground layer and run the script.
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var myComp = app.project.activeItem;
var myLayer = myComp.selectedLayers[0];

// Check to see if a layer is selected;
if(myLayer == null){
alert(" No layer selected. Please select your foreground layer.");
}else{
    
if(myComp.selectedLayers.length > 1){
    alert("More than one layer is selected. Please select your forground layer only.");
    }else{
        
// Create undo command.
app.beginUndoGroup("sb_EdgeBlend");

// Create a fg matte layer.
var matteLayer = myLayer.duplicate();
matteLayer.moveBefore(myLayer);
matteLayer.name = "edgeMatte";

// Exression link the matte layer to the fg layer.
matteLayer.position.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.position";
matteLayer.scale.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.scale";
matteLayer.rotation.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.rotation";
matteLayer.opacity.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.opacity";

if(myLayer.threeDLayer == true){
    matteLayer.orientation.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.orientation";
    matteLayer.rotationX.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.xRotation";
    matteLayer.rotationY.expression = "comp('" + myComp.name + "').layer('" + myLayer.name + "').transform.yRotation";
}

// Add effects to the matte layer.
matteLayer.property("Effects").addProperty("Shift Channels") ("Take Alpha From").setValue(9);
matteLayer.property("Effects") ("Shift Channels") ("Take Red From").setValue(1);
matteLayer.property("Effects") ("Shift Channels") ("Take Green From").setValue(1);
matteLayer.property("Effects") ("Shift Channels") ("Take Blue From").setValue(1);
matteLayer.property("Effects").addProperty("Find Edges") ("Invert").setValue(1);
matteLayer.property("Effects").addProperty("Minimax");
matteLayer.property("Effects").addProperty("Fast Blur") ("Blurriness").setValue(2);

//Create a blur layer and set default blend value. 
var blurLayer = myComp.layers.addSolid([1,1,1], "edgeBlend", myComp.width, myComp.height, myComp.pixelAspect, myComp.duration);
blurLayer.adjustmentLayer  = true;
blurLayer.moveAfter(matteLayer);
blurLayer.trackMatteType = TrackMatteType.LUMA;
blurLayer.property("Effects").addProperty("Fast Blur") ("Blurriness").setValue(1);

app.endUndoGroup();

}//if(myComp.selectedLayers.length > 1){

}// if(myLayer == null){